(def_class props
  (filename "")
  (outname  ""))

(setf settings (new props))

(defun repeat (s x)  (if (> x 1) (+ s (repeat s (- x 1)))  s))

(defun show_percent (p t)  
  (let ((w (int (* (/ (float p) t) 75))))  
    (table :allign 'left (row (col (table :frame 1 :bgcolor 0x606000 (sc (repeat "." w))))
	                               (col (sc p))))))

(defun show_results (osize new_size)
  (let ((max (if (> osize new_size) osize new_size)))
     
	  (object_edit "Compression results"
	     (table :width 1.0 :height 1.0 :cellpadding 15
		   (table :width 1.0 :height 1.0 :cellpadding 10
			 (table :width 1.0 :height 1.0 :cellpadding 5
			   
			   (row (sc :width 50 "Old Size") 
			        (col :allign 'left (show_percent osize max)))
								   
			   (row (sc :width 50 "New Size") 
			        (col :allign 'left (show_percent new_size max))))
					

               (table :width 1.0 :bgcolor 0xe0c0c0 :frame 1 
			      (if (< osize new_size)			     
				    (sc "Because the stub program is 40K in size, EZIP will often fail to compress very small program.  This is the case here.")
					(sc (+ "The compression ratio of new/old is " (/ (* 100 new_size) osize) "%"
					       "\nYou saved " (- osize new_size) " bytes" ))))
			   (table :cellpadding 2 (row (button_action :width 180 "Ok" 
			                              '(exit_dialog))
			                              (button_action :width 180 "Execute compressed program" 
									        '(system outname))))

			   )))))
		   

(defun show_error (msg)
  (object_edit "Error!"
	  (table :width 1.0 :height 1.0 :cellpadding 15	    
		   (table :width 1.0 :frame 1 :cellpadding 10 :bgcolor 0xb0b0e0 (sc "An error occured and the file could not be compressed"))
		   (table :width 1.0 (row (col (sc msg))))
		   (button_action :width 80 "Ok" '(exit_dialog)))))




(defun browse (old)
  
  (let ((result (file_browse :title "Select an Executable to Compress" :mask "Executable File (*.exe)/*.exe")))
    (if result (progn (set_out result) result) old)))


(defun dialog ()
  (with settings
  (object_edit "Ezip.  The free executable compressor"
    (table :width 1.0 :height 1.0	  
	   (table :width 1.0 :bgcolor 0xffffff :frame 1 
	      (image (+ install_path "/banner.bmp")))
	      (tab_control :height 1.0 '("Compress" "About")
		    (list
			  (table :cellpadding 5 :width 1.0 :height 1.0
				   (table :width 1.0 :bgcolor 0xd0c0c0 :frame 1
					  (sc "Welcome to EZIP 1.0!\nThis program will compress an executable and add a stub program to the executable so that it runs in it's compressed form without the need for any external decompressor.  It is a great way for developers to distribute EXE files over the internet.  EZIP also makes it much harder for someone to reverse engineer software."
					  ))
				   (table :width 1.0  :cellpadding 4
					 (row :width 1.0 
						  (col (sc "Executable to Compress"))
						  (table :width 1.0 (row (string_edit :width 1.0 'filename)
												 (button_action "Browse" '(progn 												                            
																			(setf filename (browse filename))
																			(refresh_var 'filename))))))
						  
					 (row :width 1.0 
						  (col (sc "Output Filename"))
						  (table :width 1.0 (row (string_edit :width 1.0 'outname)))))
												 

				  (table :width 1.0 (button_action "Compress It!" '(progn
																	  (apply_changes)
																	  (compress_exe filename outname)))))

				  

			  (table :cellpadding 5 :width 1.0 :height 1.0 :vallign 'top
			       
				   (table :width 1.0 :height 50  :allign 'left :vallign 'top :cellpadding 8 :frame 1
					  (row :allign 'center (col :allign 'center (sc "Facts about EZIP")))					  
					  (row :bgcolor 0xb0b0b0 (sc "- EZIP decompresses your program in memory when it is loaded, so there is never any addition disk space needed."))
					  (row :bgcolor 0xc0c0c0 (sc "- Programs that use EZIP often load faster than non-ezipped programs because the harddrive is usually much slower than the decompression."))
					  (row :bgcolor 0xb0b0b0 (sc "- EZIP compressed programs are difficult to reverse engineer because they cannot be dissassembled until after they are decompressed."))
					  (row :bgcolor 0xffffff (table :width 1.0 :bgcolor 0xffffff  
					                                 (row (col (sc (+ "- EZIP was written by Jonathan Clark\n\n"
													                  "For more free tools that I've written, visit me at http://jonathanclark.com"
													                   )))
					                                      (col :allign 'right :vallign 'bottom (image (+ install_path "/jc.bmp"))))))
                             )))))
		 )))
